// List.cpp: implementation of the List class.
//
//////////////////////////////////////////////////////////////////////

#include "List.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

List::List()
{
	head = NULL;
}

List::List(NodePtr h)
{
	head = h;
}

List::~List()
{

}


int List::length() const
{
	int answer = 0;
	NodePtr current = head;
	while (current != NULL)
	{
		current = current->getNext();
		answer++;
	}
	return answer;
}

int length_helper (NodePtr current)
{
	if (current == NULL)
		return 0;
	else
		return 1 + length_helper (current->getNext());
}


int List::recursive_length() const
{
	return length_helper(head);
}


std::string descr_helper(NodePtr current)
{
	if (current == NULL)
		return "";
	else
		return current->getFirst() + " " +
			descr_helper(current->getNext());
}

std::string List::description() const
{
	return "A list containing " + descr_helper(head);
}

std::string List::iterative_description() const
{
	std::string answer = "The list... ";
	NodePtr current = head;
	while (current != NULL)
	{
		answer += current->getFirst() + " ";
		current = current->getNext();
	}
	return answer;
}

void List::addToFront(string s)
{
	head = new Node(s,head);
}

void List::addAtPosition(string s, int where)
{
	if (where == 0)
		addToFront(s);
	else
	{
		NodePtr insertAfter = head;
		for (int i=0; i < where-1; ++i)
		{
			insertAfter = insertAfter->getNext();
		}

//		insertAfter->next = new Node(s,insertAfter->next);
// Can't do that because "next" is a private variable.  Instead,...
		insertAfter->setNext (new Node(s,insertAfter->getNext()));

	}
}

