// Node.cpp: implementation of the Node class.
//
//////////////////////////////////////////////////////////////////////

#include "Node.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Node::Node(string f, NodePtr r)
{
	first = f;
	next = r;
}

Node::~Node()
{

}

Node::Node (const Node &other)
{
	first = other.first;
	next = other.next;
}

string Node::getFirst () const
{
	return first;
}

NodePtr Node::getNext () const {
	return next;
}

/*
void Node::setNext (NodePtr newNext)
{
	next = newNext;
}
*/

void Node::iterativeRemoveAtPosition (int where)
// Assumes where > 0.
{
	NodePtr current = this;
	for (int i=0; i < where-1; ++i)
	{
		current = current->next;
	}
		
	removeAfter(current->next);
}


void Node::removeAtPosition (int where)
// assumes where > 0.
{
	if (where == 1)
		removeAfter (next);
	else
		next->removeAtPosition (where-1);
}

void Node::addAtPosition (string s, int where)
// assumes where > 0.
{
	if (where == 1)
		addAfter(s, next);
	else
		next->addAtPosition (s, where-1);
}

void removeAfter (NodePtr &prev)
{
	NodePtr temp = prev;
	prev = temp->getNext();
	delete temp;
}

void addAfter (string s, NodePtr &prev)
{
	prev = new Node(s,prev->getNext());
	// does that getNext() really belong?
}

