// Node.h: interface for the Node class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
#define AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>
using namespace std;

class Node;
typedef Node *NodePtr;

class Node  
{
private:
	string data;
	NodePtr next,prev;

	// Constructors: both private, so they can only be used by Node code.
	Node(string data_arg, NodePtr prev_arg, NodePtr next_arg);
	Node();

public:
	// The closest thing to a public constructor.
	static void makeHeadAndTail (NodePtr &head, NodePtr &tail);
	// Note that it's "static", so it can be called without an existing Node.

	virtual ~Node();

// access methods
	string getData () const;
	NodePtr getNext () const;
	NodePtr getPrev () const;
	bool isHead () const;
	bool isTail () const;

//	void setNext (NodePtr newNext);
	NodePtr stepForward (int howMany) ;
	NodePtr stepBackward (int howMany) ;
// I tried to make stepForward and stepBackward "const", on grounds that they
// themselves don't modify the data structure.  But they return a pointer to
// a Node, so either they can't be "const", or their RESULT has to be "const"
// too, which would prevent ever modifying a node that you got by stepping
// forward or backward.  I chose the former.

	void addAfter (string s);
	void addBefore (string s);
	void remove ();

	int countNodesAfter () const;
	int countNodesBefore () const;
};

#endif // !defined(AFX_NODE_H__3CF52312_CD63_11D5_8592_00C04F2B1D70__INCLUDED_)
